//This code is writed by Nikos Mourgis. (nikosmourgis@gmail.com)
//The following code is writed with the convenience in mind and not
//for efficiency. The code may contains bugs that was unnoticed while testing.
//use it freely at your convinience but please do not sell this code , and please
//do not remove this header. Last Update : 03/01/2018 

#ifndef UNICODE
#define UNICODE
#endif

#ifndef WINDOWS
#define WINDOWS
#include<windows.h>
#endif


#ifndef DYNAMICLIST
#define DYNAMICLIST
#include <DynamicList.h>
#endif




    typedef DWORD (*ThreadProc)(LPVOID);

    typedef LPVOID * LPPVOID;


    class Thread
    {

    private:
        HANDLE Handle,cHandle;
        ThreadProc Proc;
        ThreadProc ComplProc;
        DWORD Ret;
        static DWORD WINAPI ThreadFunc(LPVOID pparam);
        static DWORD WINAPI ContrFunc(LPVOID pparam);
        LPVOID Param;
        Thread *fordel;
        bool Exec;
        DWORD ID2;
        int arrc;
        void SetExec(bool e);
        void SetReturn(DWORD vl);
        void Destroy();
    public:
        DWORD ID;
        DynamicList *delpoint;//expose this member for convenience
        void SetProc(ThreadProc P);
        void CallAtCompletion(ThreadProc P);
        void SetParam(LPVOID P);
        void SetAutoDestruction(Thread *thisthread);
        void DeleteAtCompletion(DynamicList *pointers);
        HANDLE GetHandle();
        HANDLE GetcHandle();
        void Start();
        bool Terminate();
        DWORD GetReturn();
        void InitThread();
        bool GetExec();

    Thread();
    ~Thread();
    };
    

void Thread::SetProc(ThreadProc P)
{
    Proc=P;
};




    HANDLE Thread::GetHandle()
    {
      return Handle;
    };

    HANDLE Thread::GetcHandle()
    {
      return cHandle;
    };

    void Thread::SetReturn(DWORD vl)
    {
        Ret=vl;

    }

    void Thread::SetAutoDestruction(Thread *thisthread)
    {
        fordel=thisthread;
    }


void Thread::SetParam(LPVOID P)
{

    Param=P;
};

void Thread::CallAtCompletion(ThreadProc P)
{
    ComplProc=P;
}

void Thread::DeleteAtCompletion(DynamicList *pointers)
{
    if (pointers!=NULL)
    {
         delpoint = new DynamicList();

         (*delpoint)=(*pointers);

    }

}

DWORD WINAPI Thread::ThreadFunc(LPVOID pparam)
{
Thread *PThis;
PThis=(Thread*)pparam;
PThis->Proc(PThis->Param);
return 0;
};

DWORD WINAPI Thread::ContrFunc(LPVOID pparam)
{

   DWORD vl;
   Thread *thr;
   thr=(Thread*)pparam;
   WaitForSingleObject(thr->GetHandle(),INFINITE);
   GetExitCodeThread(thr->GetHandle(), &vl);
   thr->SetReturn(vl);
   CloseHandle(thr->GetHandle());
   thr->SetExec(false);

   if (thr->ComplProc!=NULL)
   {
     thr->ComplProc(thr);
   }

   if (thr->fordel!=NULL)
   delete thr->fordel;


   return 0;
};

void Thread::Destroy()
{
    this->~Thread();
}

void Thread::Start()
{

Terminate();
Handle=CreateThread(NULL,0,ThreadFunc,this, 0, &ID);


if (Handle!=NULL) Exec=true;
cHandle=CreateThread(NULL,0,ContrFunc,this, 0, &ID2); 

};

bool Thread::Terminate()
{

if (Handle!=NULL)
{
bool Res;
Res=TerminateThread(Handle,0);
if (Res)
{
    CloseHandle(Handle);
    Handle=NULL;
    Ret=(DWORD) -1;
    Exec=false;
}

 if (cHandle!=0)
    {

        DWORD res=TerminateThread(cHandle,0);
    if (res==true)
        {
            CloseHandle(cHandle);
            cHandle=NULL;
            res=(DWORD) -1;
        }
    }

return Res;
}
 return 0;
};


DWORD Thread::GetReturn()
{
    return Ret;
};

bool Thread::GetExec()
{
    return Exec;
};

void Thread::SetExec(bool e)
{
  Exec=e;
};

void Thread::InitThread()
{
if (Exec==false)
{
Handle=NULL;
Proc=NULL;
ComplProc=NULL;
Ret=0;
Param=NULL;
cHandle=NULL;
fordel=NULL;
}

};

Thread::Thread()
{
Handle=NULL;
cHandle=NULL;
Proc=NULL;
ComplProc=NULL;
Ret=0;
Param=NULL;
Exec=false;
fordel=NULL;
ID=0;
delpoint=NULL;
};


Thread::~Thread()
{
    if (delpoint!=NULL)
    delete delpoint;
if (Exec==true) Terminate();

};












